<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Rezept Sammlung</title>
    <style>
      body {
        font-family: Arial, sans-serif;
        margin: 20px;
      }
      table {
        width: 100%;
        border-collapse: collapse;
      }
      table,
      th,
      td {
        border: 1px solid black;
      }
      th,
      td {
        padding: 10px;
        text-align: left;
      }
      th {
        background-color: #f2f2f2;
      }
    </style>
  </head>
  <body>
    <h1>Rezept Sammlung</h1>

    <h2>Alle Rezepte</h2>
    <table id="rezepteTable">
      <thead>
        <tr>
          <th>ID</th>
          <th>Name</th>
          <th>Kategorie</th>
          <th>Anleitung</th>
          <th>Aktionen</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table>

    <h2>Neues Rezept hinzufügen</h2>
    <form id="addRecipeForm">
      <label for="name">Name:</label>
      <input type="text" id="name" name="name" required /><br /><br />
      <label for="kategorie">Kategorie:</label>
      <input type="text" id="kategorie" name="kategorie" required /><br /><br />
      <label for="anleitung">Anleitung:</label><br />
      <textarea
        id="anleitung"
        name="anleitung"
        rows="4"
        cols="50"
        required
      ></textarea
      ><br /><br />
      <input type="submit" value="Hinzufügen" />
    </form>

    <script>
      async function fetchRezepte() {
        const response = await fetch("/rezepte");
        const rezepte = await response.json();
        const tbody = document.querySelector("#rezepteTable tbody");
        tbody.innerHTML = "";
        rezepte.forEach((rezept) => {
          const tr = document.createElement("tr");
          tr.innerHTML = `
          <td>${rezept.rezept_id}</td>
          <td>${rezept.name}</td>
          <td>${rezept.kategorie}</td>
          <td>${rezept.anleitung}</td>
          <td><button onclick="deleteRezept('${rezept.rezept_id}')">Löschen</button></td>
        `;
          tbody.appendChild(tr);
        });
      }

      async function addRezept(event) {
        event.preventDefault();
        const form = document.getElementById("addRecipeForm");
        const formData = new FormData(form);
        const name = formData.get("name");
        const kategorie = formData.get("kategorie");
        const anleitung = formData.get("anleitung");

        await fetch("/rezepte", {
          method: "POST",
          headers: {
            "Content-Type": "application/json",
          },
          body: JSON.stringify({ name, kategorie, anleitung }),
        });

        form.reset();
        fetchRezepte();
      }

      async function deleteRezept(id) {
        await fetch(`/rezepte/${id}`, {
          method: "DELETE",
        });
        fetchRezepte();
      }

      document
        .getElementById("addRecipeForm")
        .addEventListener("submit", addRezept);
      fetchRezepte();
    </script>
  </body>
</html>
